Index: org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.app/org.gvsig.topology.app.mainplugin/src/main/java/org/gvsig/topology/app/mainplugin/AppTopologyServices.java
===================================================================
--- org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.app/org.gvsig.topology.app.mainplugin/src/main/java/org/gvsig/topology/app/mainplugin/AppTopologyServices.java	(revision 726)
+++ org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.app/org.gvsig.topology.app.mainplugin/src/main/java/org/gvsig/topology/app/mainplugin/AppTopologyServices.java	(revision 727)
@@ -23,30 +23,55 @@
  */
 package org.gvsig.topology.app.mainplugin;
 
+import java.io.File;
 import java.util.ArrayList;
 import java.util.HashMap;
 import java.util.List;
 import java.util.Map;
+import javax.swing.ImageIcon;
 import javax.swing.tree.TreeModel;
 import org.apache.commons.lang3.mutable.Mutable;
 import org.apache.commons.lang3.mutable.MutableObject;
+import org.gvsig.andami.IconThemeHelper;
+import org.gvsig.andami.PluginsLocator;
 import org.gvsig.app.ApplicationLocator;
 import org.gvsig.app.ApplicationManager;
 import org.gvsig.app.project.Project;
 import org.gvsig.app.project.documents.Document;
 import org.gvsig.app.project.documents.view.ViewDocument;
 import org.gvsig.app.project.documents.view.ViewManager;
+import org.gvsig.fmap.dal.EditingNotification;
+import org.gvsig.fmap.dal.EditingNotificationManager;
 import org.gvsig.fmap.dal.feature.FeatureStore;
+import org.gvsig.fmap.dal.swing.DALSwingLocator;
+import org.gvsig.fmap.geom.Geometry;
+import org.gvsig.fmap.geom.aggregate.MultiCurve;
+import org.gvsig.fmap.geom.aggregate.MultiPoint;
+import org.gvsig.fmap.geom.aggregate.MultiSurface;
+import org.gvsig.fmap.geom.primitive.Curve;
 import org.gvsig.fmap.geom.primitive.Envelope;
 import org.gvsig.fmap.geom.primitive.Point;
+import org.gvsig.fmap.geom.primitive.Surface;
+import org.gvsig.fmap.mapcontext.MapContext;
+import org.gvsig.fmap.mapcontext.MapContextLocator;
 import org.gvsig.fmap.mapcontext.ViewPort;
 import org.gvsig.fmap.mapcontext.events.ColorEvent;
 import org.gvsig.fmap.mapcontext.events.ExtentEvent;
 import org.gvsig.fmap.mapcontext.events.ProjectionEvent;
 import org.gvsig.fmap.mapcontext.events.listeners.ViewPortListener;
+import org.gvsig.fmap.mapcontext.layers.FLayer;
 import org.gvsig.fmap.mapcontext.layers.FLayers;
 import org.gvsig.fmap.mapcontext.layers.vectorial.FLyrVect;
+import org.gvsig.fmap.mapcontext.layers.vectorial.GraphicLayer;
+import org.gvsig.fmap.mapcontext.rendering.symbols.ISymbol;
+import org.gvsig.fmap.mapcontext.rendering.symbols.ISymbol_v2;
+import org.gvsig.fmap.mapcontrol.MapControlLocator;
+import org.gvsig.fmap.mapcontrol.swing.dynobject.DynObjectEditor;
+import org.gvsig.tools.dynobject.DynObject;
 import org.gvsig.tools.exception.BaseException;
+import org.gvsig.tools.observer.Observable;
+import org.gvsig.tools.observer.Observer;
+import org.gvsig.tools.swing.api.ListElement;
 import org.gvsig.tools.visitor.VisitCanceledException;
 import org.gvsig.tools.visitor.Visitor;
 import org.gvsig.topology.lib.api.TopologyDataSet;
@@ -62,12 +87,12 @@
 public class AppTopologyServices implements TopologySwingServices {
 
     private static final Logger LOGGER = LoggerFactory.getLogger(AppTopologyServices.class);
- 
+
     private class WorkingAreaViewPortListener implements ViewPortListener {
-    
+
         private WorkingAreaChangedListener workingAreaChangedListener;
         private ViewPort viewPort;
-        
+
         public WorkingAreaViewPortListener(ViewPort viewPort, WorkingAreaChangedListener workingAreaChangedListener) {
             this.workingAreaChangedListener = workingAreaChangedListener;
             this.viewPort = viewPort;
@@ -76,7 +101,7 @@
         public ViewPort getViewPort() {
             return this.viewPort;
         }
-        
+
         @Override
         public void extentChanged(ExtentEvent e) {
             this.workingAreaChangedListener.workingAreaChanged(e.getNewExtent());
@@ -91,12 +116,43 @@
         }
     }
 
+    private class EditingNotificationObserver implements Observer {
+
+        public EditingNotificationObserver() {
+
+        }
+
+        @Override
+        public void update(Observable o, Object notification) {
+            EditingNotification n = (EditingNotification) notification;
+            if (n.isCancelable() && n.getFeature() != null) {
+                try {
+                    DynObject data = n.getFeature().getAsDynObject();
+                    DynObjectEditor editor = new DynObjectEditor(data);
+                    editor.setTitle("Topology - " + n.getFeature().getType().getName());
+                    editor.editObject(true);
+                    if (editor.isCanceled()) {
+                        n.cancel();
+                    } else {
+                        editor.getData(data);
+                    }
+                } catch (Exception ex) {
+                    LOGGER.warn("Problems showing the feature in a form.", ex);
+                }
+            }
+        }
+    }
+
     private Map<WorkingAreaChangedListener, WorkingAreaViewPortListener> workingAreaListener;
-    
+    private ISymbol errorPolygonSymbol = null;
+    private ISymbol errorPointSymbol = null;
+    private ISymbol errorLineSymbol = null;
+    private EditingNotificationObserver editingNotificationObserver = null;
+
     public AppTopologyServices() {
         this.workingAreaListener = new HashMap<>();
     }
-    
+
     @Override
     public TreeModel getDataSetTreeModel() {
         ApplicationManager application = ApplicationLocator.getManager();
@@ -108,26 +164,26 @@
     public FeatureStore getFeatureStore(final TopologyDataSet dataSet) {
         final Mutable<FeatureStore> store = new MutableObject<>();
         store.setValue(null);
-        
+
         ApplicationManager application = ApplicationLocator.getManager();
         Project project = application.getCurrentProject();
-        
+
         List<Document> views = new ArrayList<>();
         views.add(project.getActiveDocument(ViewManager.TYPENAME));
 //        views.addAll(project.getDocuments(ViewManager.TYPENAME));
 
         for (Document view : views) {
-            if( view == null ) {
+            if (view == null) {
                 continue;
             }
-            FLayers layers = ((ViewDocument)view).getMapContext().getLayers();
+            FLayers layers = ((ViewDocument) view).getMapContext().getLayers();
             try {
                 layers.accept(new Visitor() {
                     @Override
                     public void visit(Object o) throws VisitCanceledException, BaseException {
-                        if( o instanceof FLyrVect ) {
+                        if (o instanceof FLyrVect) {
                             FLyrVect layer = (FLyrVect) o;
-                            if( dataSet.isThisStore(layer.getFeatureStore()) ) {
+                            if (dataSet.isThisStore(layer.getFeatureStore())) {
                                 store.setValue(layer.getFeatureStore());
                                 throw new VisitCanceledException();
                             }
@@ -147,7 +203,7 @@
     public void zoomTo(Envelope envelope) {
         ApplicationManager application = ApplicationLocator.getManager();
         ViewDocument viewdoc = (ViewDocument) application.getActiveDocument(ViewManager.TYPENAME);
-        if( viewdoc == null ) {
+        if (viewdoc == null) {
             return;
         }
         ViewPort viewPort = viewdoc.getMapContext().getViewPort();
@@ -159,7 +215,7 @@
         try {
             ApplicationManager application = ApplicationLocator.getManager();
             ViewDocument viewdoc = (ViewDocument) application.getActiveDocument(ViewManager.TYPENAME);
-            if( viewdoc == null ) {
+            if (viewdoc == null) {
                 return;
             }
             viewdoc.getMapContext().invalidate();
@@ -167,13 +223,13 @@
             LOGGER.warn("Cant refresh view", ex);
         }
     }
-    
+
     @Override
     public void centerTo(Point point) {
         try {
             ApplicationManager application = ApplicationLocator.getManager();
             ViewDocument viewdoc = (ViewDocument) application.getActiveDocument(ViewManager.TYPENAME);
-            if( viewdoc == null ) {
+            if (viewdoc == null) {
                 return;
             }
             ViewPort viewPort = viewdoc.getMapContext().getViewPort();
@@ -189,7 +245,7 @@
     public Envelope getWorkingArea() {
         ApplicationManager application = ApplicationLocator.getManager();
         ViewDocument viewdoc = (ViewDocument) application.getActiveDocument(ViewManager.TYPENAME);
-        if( viewdoc == null ) {
+        if (viewdoc == null) {
             return null;
         }
         ViewPort viewPort = viewdoc.getMapContext().getViewPort();
@@ -200,16 +256,16 @@
     public void addWorkingAreaChangedListener(WorkingAreaChangedListener listener) {
         ApplicationManager application = ApplicationLocator.getManager();
         ViewDocument viewdoc = (ViewDocument) application.getActiveDocument(ViewManager.TYPENAME);
-        if( viewdoc == null ) {
+        if (viewdoc == null) {
             return;
         }
         ViewPort viewPort = viewdoc.getMapContext().getViewPort();
         WorkingAreaViewPortListener viewPortListener = this.workingAreaListener.get(listener);
-        if( viewPortListener==null ) {
+        if (viewPortListener == null) {
             viewPortListener = new WorkingAreaViewPortListener(viewPort, listener);
             this.workingAreaListener.put(listener, viewPortListener);
         } else {
-            if( viewPort != viewPortListener.getViewPort() ) {
+            if (viewPort != viewPortListener.getViewPort()) {
                 viewPortListener.getViewPort().removeViewPortListener(viewPortListener);
                 viewPortListener = new WorkingAreaViewPortListener(viewPort, listener);
                 this.workingAreaListener.put(listener, viewPortListener);
@@ -221,11 +277,80 @@
     @Override
     public void removeWorkingAreaChangedListener(WorkingAreaChangedListener listener) {
         WorkingAreaViewPortListener viewPortListener = this.workingAreaListener.get(listener);
-        if( viewPortListener==null ) {
+        if (viewPortListener == null) {
             return;
         }
-        viewPortListener.getViewPort().removeViewPortListener(viewPortListener);     
+        viewPortListener.getViewPort().removeViewPortListener(viewPortListener);
     }
-    
-    
+
+    @Override
+    public void addError(Geometry geom) {
+        if (this.errorPointSymbol == null) {
+            try {
+                File pluginfolder = PluginsLocator.getManager().getPlugin(this).getPluginDirectory();
+                File folder = new File(pluginfolder, "symbols");
+                ISymbol[] symbols = MapContextLocator.getSymbolManager().loadSymbols(folder);
+                for (ISymbol symbol : symbols) {
+                    if (symbol instanceof ISymbol_v2) {
+                        String symbolid = ((ISymbol_v2) symbol).getID();
+                        switch(symbolid) {
+                            case "topology-error-polygon":
+                                this.errorPolygonSymbol = symbol;
+                                break;
+                            case "topology-error-line":
+                                this.errorLineSymbol = symbol;
+                                break;
+                            case "topology-error-point":
+                                this.errorPointSymbol = symbol;
+                                break;
+                        }
+                    }
+                }
+            } catch (Exception ex) {
+            }
+        }
+        ApplicationManager application = ApplicationLocator.getManager();
+        ViewDocument viewdoc = (ViewDocument) application.getActiveDocument(ViewManager.TYPENAME);
+        MapContext mapContext = viewdoc.getMapContext();
+        GraphicLayer gl = mapContext.getGraphicsLayer();
+        gl.removeGraphics("topology-errors");
+        if ( geom!=null ) {
+            ISymbol symbol = null;
+            if( geom instanceof Point || geom instanceof MultiPoint) {
+                symbol = this.errorPointSymbol;
+            } else if( geom instanceof Curve || geom instanceof MultiCurve ) {
+                symbol = this.errorLineSymbol;
+            } else if( geom instanceof Surface || geom instanceof MultiSurface ) {
+                symbol = this.errorPolygonSymbol;
+            }
+            if (symbol != null) {
+                int symbolid = gl.getSymbolId(symbol);
+                if (symbolid < 0) {
+                    gl.addSymbol(symbol);
+                    symbolid = gl.getSymbolId(symbol);
+                }
+                gl.addGraphic("topology-errors", geom, symbolid);
+            }
+        }
+        mapContext.invalidate();
+    }
+
+    @Override
+    public void setShowFormWhenEdit(boolean showFormWhenEdit) {
+        if (this.editingNotificationObserver == null) {
+            this.editingNotificationObserver = new EditingNotificationObserver();
+        }
+        EditingNotificationManager editingNotificationManager = DALSwingLocator.getEditingNotificationManager();
+        if (showFormWhenEdit) {
+            editingNotificationManager.addObserver(this.editingNotificationObserver);
+        } else {
+            editingNotificationManager.deleteObserver(this.editingNotificationObserver);
+        }
+    }
+
+    @Override
+    public ImageIcon getTreeIcon(TreeModel model, Object item) {
+        return ((DataSetsTreeModel)model).getTreeIcon(item);
+    }
+
 }
Index: org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.app/org.gvsig.topology.app.mainplugin/src/main/java/org/gvsig/topology/app/mainplugin/DataSetsTreeModel.java
===================================================================
--- org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.app/org.gvsig.topology.app.mainplugin/src/main/java/org/gvsig/topology/app/mainplugin/DataSetsTreeModel.java	(revision 726)
+++ org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.app/org.gvsig.topology.app.mainplugin/src/main/java/org/gvsig/topology/app/mainplugin/DataSetsTreeModel.java	(revision 727)
@@ -23,15 +23,20 @@
  */
 package org.gvsig.topology.app.mainplugin;
 
+import javax.swing.ImageIcon;
 import javax.swing.event.TreeModelListener;
 import javax.swing.tree.TreeModel;
 import javax.swing.tree.TreePath;
+import org.gvsig.andami.IconThemeHelper;
 import org.gvsig.app.project.documents.view.ViewDocument;
-import org.gvsig.fmap.dal.feature.FeatureStore;
-import org.gvsig.fmap.mapcontext.layers.vectorial.FLyrVect;
+import org.gvsig.fmap.dal.DataStore;
+import org.gvsig.fmap.mapcontext.MapContextLocator;
+import org.gvsig.fmap.mapcontext.layers.FLayer;
+import org.gvsig.fmap.mapcontext.layers.operations.SingleLayer;
 import org.gvsig.fmap.mapcontrol.CompoundLayersTreeModel;
 import org.gvsig.fmap.mapcontrol.MapControlLocator;
 import org.gvsig.tools.swing.api.ListElement;
+import org.gvsig.topology.lib.api.TopologyDataSet;
 import org.gvsig.topology.lib.api.TopologyLocator;
 import org.gvsig.topology.swing.api.TopologySwingServices;
 
@@ -72,9 +77,9 @@
     public Object getChild(Object parent, int index) {
         parent = this.getNode(parent);
         Object x = this.deletaged.getChild(parent, index);
-        if( x instanceof FLyrVect ) {
-            FLyrVect layer = (FLyrVect)x;
-            FeatureStore store = layer.getFeatureStore();
+        if( x instanceof SingleLayer ) {
+            SingleLayer layer = (SingleLayer)x;
+            DataStore store = layer.getDataStore();
             x = TopologyLocator.getTopologyManager().createDataSet(
                     layer.getName(),
                     store
@@ -115,5 +120,27 @@
     public void removeTreeModelListener(TreeModelListener l) {
         this.deletaged.removeTreeModelListener(l);
     }
+
+    public ImageIcon getTreeIcon(Object item) {
+        if( this.getRoot()==item ) {
+            return IconThemeHelper.getImageIcon("topology-tree-project");
+        }
+        if (item instanceof ListElement) {
+            item = ((ListElement) item).getValue();
+        }
+        if( this.view.getMapContext().getLayers()==item ) {
+            return IconThemeHelper.getImageIcon("document-view-tree-icon");
+        }
+        if (item instanceof TopologyDataSet) {
+            DataStore store = ((TopologyDataSet)item).getStore();
+            String iconName = MapContextLocator.getMapContextManager().getIconLayer(store);
+            return IconThemeHelper.getImageIcon(iconName);
+        }
+        if (item instanceof FLayer) {
+            String iconName = ((FLayer) item).getTocImageIcon();
+            return IconThemeHelper.getImageIcon(iconName);
+        }
+        return IconThemeHelper.getImageIcon("topology-tree-folder");
+    }
     
 }
Index: org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.app/org.gvsig.topology.app.mainplugin/src/main/java/org/gvsig/topology/app/mainplugin/TopologyExtension.java
===================================================================
--- org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.app/org.gvsig.topology.app.mainplugin/src/main/java/org/gvsig/topology/app/mainplugin/TopologyExtension.java	(revision 726)
+++ org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.app/org.gvsig.topology.app.mainplugin/src/main/java/org/gvsig/topology/app/mainplugin/TopologyExtension.java	(revision 727)
@@ -26,6 +26,7 @@
 import java.awt.event.ActionEvent;
 import java.awt.event.ActionListener;
 import org.apache.commons.lang.StringUtils;
+import org.gvsig.andami.IconThemeHelper;
 import org.gvsig.andami.plugins.Extension;
 import org.gvsig.app.ApplicationLocator;
 import org.gvsig.app.ApplicationManager;
@@ -66,7 +67,10 @@
         
         TopologySwingManager swingManager = TopologySwingLocator.getTopologySwingManager();
         swingManager.setDefaultServices(services);
-        
+  
+        IconThemeHelper.registerIcon("document", "document-view-tree-icon", this);
+        IconThemeHelper.registerIcon("topology", "topology-tree-folder", this);
+        IconThemeHelper.registerIcon("topology", "topology-tree-project", this);
     }
 
     
Index: org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.impl/src/main/java/org/gvsig/topology/lib/impl/DefaultTopologyManager.java
===================================================================
--- org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.impl/src/main/java/org/gvsig/topology/lib/impl/DefaultTopologyManager.java	(revision 726)
+++ org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.impl/src/main/java/org/gvsig/topology/lib/impl/DefaultTopologyManager.java	(revision 727)
@@ -27,6 +27,7 @@
 import java.util.Collections;
 import java.util.List;
 import org.apache.commons.lang3.StringUtils;
+import org.gvsig.fmap.dal.DataStore;
 import org.gvsig.fmap.dal.feature.FeatureStore;
 import org.gvsig.topology.lib.api.TopologyDataSet;
 import org.gvsig.topology.lib.api.TopologyManager;
@@ -85,7 +86,7 @@
     }
 
     @Override
-    public TopologyDataSet createDataSet(String name, FeatureStore store) {
+    public TopologyDataSet createDataSet(String name, DataStore store) {
         TopologyDataSet dataSet = new DefaultTopologyDataSet(this.services, name, store);
         return dataSet;
     }
Index: org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.impl/src/main/java/org/gvsig/topology/lib/impl/DefaultTopologyPlan.java
===================================================================
--- org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.impl/src/main/java/org/gvsig/topology/lib/impl/DefaultTopologyPlan.java	(revision 726)
+++ org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.impl/src/main/java/org/gvsig/topology/lib/impl/DefaultTopologyPlan.java	(revision 727)
@@ -30,6 +30,7 @@
 import java.util.HashMap;
 import java.util.List;
 import java.util.Map;
+import org.gvsig.fmap.dal.DataStore;
 import org.gvsig.fmap.dal.feature.FeatureStore;
 import org.gvsig.fmap.geom.GeometryLocator;
 import org.gvsig.fmap.geom.GeometryManager;
@@ -165,7 +166,7 @@
     }
 
     @Override
-    public TopologyDataSet addDataSet(String name, FeatureStore store) {
+    public TopologyDataSet addDataSet(String name, DataStore store) {
         TopologyDataSet dataSet = manager.createDataSet(name, store);
         return this.addDataSet(dataSet);
     }
@@ -313,7 +314,7 @@
         for (Object o : jsonRules) {
             JSONObject jsonRule = (JSONObject) o;
             TopologyRuleFactory factory = this.manager.getRulefactory(jsonRule.getString("__factoryId"));
-            TopologyRule rule = factory.createRule(this);
+            TopologyRule rule = factory.createRule(this,null, null, -1);
             rule.fromJSON(jsonRule);
             this.addRule(rule);
         }        
Index: org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.impl/src/main/java/org/gvsig/topology/lib/impl/DefaultTopologyReport.java
===================================================================
--- org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.impl/src/main/java/org/gvsig/topology/lib/impl/DefaultTopologyReport.java	(revision 726)
+++ org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.impl/src/main/java/org/gvsig/topology/lib/impl/DefaultTopologyReport.java	(revision 727)
@@ -30,15 +30,12 @@
 import org.gvsig.expressionevaluator.ExpressionEvaluatorLocator;
 import org.gvsig.expressionevaluator.ExpressionEvaluatorManager;
 import org.gvsig.expressionevaluator.MutableSymbolTable;
-import org.gvsig.expressionevaluator.spi.AbstractSymbolTable;
 import org.gvsig.fmap.dal.feature.FeatureReference;
 import org.gvsig.fmap.geom.Geometry;
 import org.gvsig.tools.task.SimpleTaskStatus;
 import org.gvsig.topology.lib.api.TopologyDataSet;
 import org.gvsig.topology.lib.api.TopologyPlan;
 import org.gvsig.topology.lib.api.TopologyReport;
-import static org.gvsig.topology.lib.api.TopologyReport.IS_ERROR;
-import static org.gvsig.topology.lib.api.TopologyReport.RULE_ID;
 import org.gvsig.topology.lib.api.TopologyReportLine;
 import org.gvsig.topology.lib.api.TopologyReportLineSet;
 import org.gvsig.topology.lib.api.TopologyRule;
@@ -72,6 +69,7 @@
             }
             SimpleTaskStatus theTaskStatus = plan.getTaskStatus();
             try {
+                theTaskStatus.push();
                 theTaskStatus.restart();
                 theTaskStatus.message("Preparing filter");
                 theTaskStatus.setAutoremove(true);
@@ -105,6 +103,7 @@
                 if (theTaskStatus.isRunning()) {
                     theTaskStatus.terminate();
                 }
+                theTaskStatus.pop();
                 this.completed = true;
             }
         }
@@ -121,13 +120,13 @@
 
     @Override
     public TopologyReportLine addLine(TopologyRule rule, TopologyDataSet dataSet1,
-            TopologyDataSet dataSet2, Geometry geometry,
+            TopologyDataSet dataSet2, Geometry geometry, Geometry error,
             FeatureReference feature1, FeatureReference feature2,
             boolean exception, String description
     ) {
         TopologyReportLine line = new DefaultTopologyReportLine(
-                this, rule, dataSet1, dataSet2, geometry, feature1, feature2,
-                exception, description
+                this, rule, dataSet1, dataSet2, geometry, error, feature1, 
+                feature2, exception, description
         );
         this.lines.add(line);
         this.changeListenerHelper.fireEvent();
Index: org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.impl/src/main/java/org/gvsig/topology/lib/impl/DefaultTopologyReportLine.java
===================================================================
--- org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.impl/src/main/java/org/gvsig/topology/lib/impl/DefaultTopologyReportLine.java	(revision 726)
+++ org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.impl/src/main/java/org/gvsig/topology/lib/impl/DefaultTopologyReportLine.java	(revision 727)
@@ -45,12 +45,14 @@
     private final FeatureReference feature2;
     private boolean exception;
     private final String description;
+    private Geometry errorGeometry;
     
     DefaultTopologyReportLine(DefaultTopologyReport report, 
             TopologyRule rule, 
             TopologyDataSet dataSet1, 
             TopologyDataSet dataSet2, 
             Geometry geometry,
+            Geometry error,
             FeatureReference feature1, 
             FeatureReference feature2, 
             boolean exception,
@@ -65,6 +67,7 @@
         this.feature2 = feature2;
         this.exception = exception;
         this.description = description;
+        this.errorGeometry = error;
     }
 
     @Override
@@ -110,4 +113,9 @@
     public String getDescription() {
         return description;
     }
+
+    @Override
+    public Geometry getError() {
+        return this.errorGeometry;
+    }
 }
Index: org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.impl/src/main/java/org/gvsig/topology/lib/impl/DefaultTopologyDataSet.java
===================================================================
--- org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.impl/src/main/java/org/gvsig/topology/lib/impl/DefaultTopologyDataSet.java	(revision 726)
+++ org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.impl/src/main/java/org/gvsig/topology/lib/impl/DefaultTopologyDataSet.java	(revision 727)
@@ -29,6 +29,7 @@
 import org.apache.commons.lang3.StringUtils;
 import org.apache.commons.lang3.mutable.MutableObject;
 import org.gvsig.expressionevaluator.Expression;
+import org.gvsig.fmap.dal.DataStore;
 import org.gvsig.fmap.dal.EditingNotification;
 import org.gvsig.fmap.dal.EditingNotificationManager;
 import org.gvsig.fmap.dal.exception.DataException;
@@ -70,7 +71,7 @@
     
     private TopologyServices services;
     private String name;
-    private FeatureStore store;
+    private DataStore store;
     private boolean needFinishEditing;
     private String fullName;
     private PropertiesSupportHelper propertiesHelper;
@@ -85,7 +86,7 @@
         this.propertiesHelper = new PropertiesSupportHelper();
     }
 
-    public DefaultTopologyDataSet(TopologyServices services, String name, FeatureStore store) {
+    public DefaultTopologyDataSet(TopologyServices services, String name, DataStore store) {
         this.services = services;
         this.name = name;
         this.store = store;
@@ -128,7 +129,7 @@
     @Override
     public String toString() {
         try {
-            FeatureAttributeDescriptor attr = this.getStore().getDefaultFeatureType().getDefaultGeometryAttribute();
+            FeatureAttributeDescriptor attr = this.getFeatureStore().getDefaultFeatureType().getDefaultGeometryAttribute();
             String geomType = attr.getGeomType().getName();
             return this.name + " ("+ geomType + ")";
         } catch(Exception ex) {
@@ -137,7 +138,7 @@
     }
 
     @Override
-    public FeatureStore getStore() {
+    public DataStore getStore() {
         if (this.store == null) {
             this.store = this.services.getFeatureStore(this);
         }
@@ -145,9 +146,17 @@
     }
 
     @Override
+    public FeatureStore getFeatureStore() {
+        if (this.store == null) {
+            this.store = this.services.getFeatureStore(this);
+        }
+        return (FeatureStore) this.store;
+    }
+
+    @Override
     public long getSize() {
         try {
-            long size = this.getStore().getFeatureCount();
+            long size = this.getFeatureStore().getFeatureCount();
             return size;
         } catch (DataException ex) {
             // TODO: mensage al log
@@ -166,7 +175,7 @@
     @Override
     public int getGeometryType() {
         try {
-            FeatureStore theStore = this.getStore();
+            FeatureStore theStore = this.getFeatureStore();
             FeatureType featureType = theStore.getDefaultFeatureType();
             FeatureAttributeDescriptor attr = featureType.getDefaultGeometryAttribute();
             GeometryType geomType = attr.getGeomType();
@@ -178,7 +187,7 @@
 
     @Override
     public void accept(Visitor visitor) throws VisitCanceledException {
-        FeatureStore st = this.getStore();
+        FeatureStore st = this.getFeatureStore();
         try {
             st.accept(visitor);
         } catch(VisitCanceledException ex) {
@@ -190,7 +199,7 @@
 
     @Override
     public void edit() throws DataException {
-        FeatureStore theStore = this.getStore();
+        FeatureStore theStore = this.getFeatureStore();
         if (!theStore.isEditing()) {
             theStore.edit();
             this.needFinishEditing = true;
@@ -200,13 +209,13 @@
     @Override
     public void finishEditing() throws DataException {
         if (this.needFinishEditing) {
-            this.getStore().finishEditing();
+            this.getFeatureStore().finishEditing();
         }
     }
 
     @Override
     public EditableFeature createNewFeature() throws DataException {
-        EditableFeature f = this.getStore().createNewFeature();
+        EditableFeature f = this.getFeatureStore().createNewFeature();
         return f;
     }
 
@@ -218,7 +227,7 @@
 
         EditingNotificationManager editingNotificationManager
                 = DALSwingLocator.getEditingNotificationManager();
-        FeatureStore theStore = this.getStore();
+        FeatureStore theStore = this.getFeatureStore();
         
         EditingNotification notification
                 = editingNotificationManager.notifyObservers(this, // source
@@ -344,7 +353,7 @@
     public SpatialIndex getSpatialIndex() {
         if( this.spatialIndex == null ) {
             this.spatialIndex = new MutableObject<>();
-            FeatureStore theStore = this.getStore();
+            FeatureStore theStore = this.getFeatureStore();
             FeatureStoreProviderFactory storeFactory = (FeatureStoreProviderFactory) theStore.getProviderFactory();
             if( storeFactory.useLocalIndexesCanImprovePerformance()==FeatureStoreProviderFactory.YES ) {
                 try {
@@ -396,7 +405,7 @@
     @Override
     public Feature findFirst(Expression filter) {
         try {
-            return this.getStore().findFirst(filter);
+            return this.getFeatureStore().findFirst(filter);
         } catch (Exception ex) {
             return null;
         }
